#!/usr/bin/env perl

# Author: Alexander Kolodziej (Tactel AB)

# this script takes two arguments
# $1 - a perl file name (file that contains variables)
# $2 - a name of a variable/array/hash to extract
#
# outputs:
#	if found			the value
#	if erroneous variable type	"UNKNOWN VARIABLE TYPE" (exit 1)
#	if non existing variable	"UNKNOWN VARIABLE"      (exit 2)

my $source = $ARGV[0];
my $variable = $ARGV[1];
my $vartype = substr($ARGV[1],0,1);
my $vartail = substr($ARGV[1],1);

require $source;

eval "if (! $variable) {print 'UNKNOWN VARIABLE\n'; exit 2;}";

if ($vartype eq "\$")
{
	#print "SCALAR VARIABLE TYPE\n";
	eval "print \$$vartail.\"\n\";";
}
elsif ($vartype eq "\@")
{
	#print "ARRAY VARIABLE TYPE\n";
	eval "foreach ( \@{\$$vartail} ) { print \$_.\"\n\";}";
}
elsif ($vartype eq "\%")
{
	#print "HASH VARIABLE TYPE\n";
	eval "foreach (keys \$$vartail) { print \"\$_=\$$vartail\{\$_\}\n\";}";
}
else
{
	print "UNKNOWN VARIABLE TYPE\n";
	exit(1);
}

exit(0);
